package cas.cordova.plugin;

import androidx.annotation.NonNull;

import com.cleversolutions.ads.AdCallback;
import com.cleversolutions.ads.AdError;
import com.cleversolutions.ads.AdStatusHandler;
import com.cleversolutions.ads.AdViewListener;
import com.cleversolutions.ads.android.CASBannerView;

import org.jetbrains.annotations.NotNull;

import cas.cordova.plugin.CASCBridge;

class CASBannerCallbackWrapper implements AdViewListener {
    private final CASCBridge parent;
    private final int adType;

    public CASBannerCallbackWrapper(int adType, CASCBridge parent) {
        this.adType = adType;
        this.parent = parent;
    }

    @Override
    public void onAdViewClicked(@NonNull CASBannerView casBannerView) {
        parent.fireEventTrigger(adType + "_Clicked");
    }

    @Override
    public void onAdViewFailed(@NonNull CASBannerView casBannerView, @NonNull AdError adError) {
        parent.fireEventTrigger(adType + "_Failed");
    }

    @Override
    public void onAdViewLoaded(@NonNull CASBannerView casBannerView) {
        parent.fireEventTrigger(adType + "_Loaded");
    }

    @Override
    public void onAdViewPresented(@NonNull CASBannerView casBannerView, @NonNull AdStatusHandler adStatusHandler) {
        parent.fireEventTrigger(adType + "_Shown");
    }
}
