package cas.cordova.plugin;

import com.cleversolutions.ads.AdCallback;
import com.cleversolutions.ads.AdStatusHandler;

import org.jetbrains.annotations.NotNull;

class CASCallbackWrapper implements AdCallback {
    private final CASCBridge parent;
    private final int adType;

    public CASCallbackWrapper(int adType, CASCBridge parent) {
        this.adType = adType;
        this.parent = parent;
    }

    @Override
    public void onShown(@NotNull AdStatusHandler adStatusHandler) {
        parent.fireEventTrigger(adType + "_Shown");
    }

    @Override
    public void onShowFailed(@NotNull String s) {
        parent.fireEventTrigger(adType + "_ShowFailed");
    }

    @Override
    public void onClicked() {
        parent.fireEventTrigger(adType + "_Clicked");
    }

    @Override
    public void onComplete() {
        parent.fireEventTrigger(adType + "_Complete");
    }

    @Override
    public void onClosed() {
        parent.fireEventTrigger(adType + "_Closed");
    }
}
