//
//  CASCCallback.m
//  CleverAdsSolutions Construct
//
//  Copyright © 2020 Clever Ads Solutions. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "CASCCallback.h"

@implementation CASCCallback 

- (id) initWithCommandDelegate:(__weak id<CDVCommandDelegate>)myCommandDelegate withCASType:(int)myAdType withViewController:(UIViewController *)myViewController {
    self = [super init];
    if (self) {
        _commandDelegate = myCommandDelegate;
        _adType = myAdType;
        _viewController = myViewController;
    }
    return self;
}

- (UIViewController * _Nonnull)viewControllerForPresentingAppReturnAd {
    return _viewController;
}

- (void)willShownWithAd:(id <CASStatusHandler> _Nonnull)adStatus {
    [self fireEventTrigger:@"_Shown"];
}

- (void)didShowAdFailedWithError:(NSString * _Nonnull)error {
    [self fireEventTrigger:@"_ShowFailed"];
}

- (void)didClickedAd {
    [self fireEventTrigger:@"_Clicked"];
}

- (void)didCompletedAd {
    [self fireEventTrigger:@"_Complete"];
}

- (void)didClosedAd {
    [self fireEventTrigger:@"_Closed"];
}

- (void)fireEventTrigger:(NSString *)event
{
    if (self.commandDelegate != nil) {
        NSString *result = [NSString stringWithFormat:@"%d", _adType];
        result = [result stringByAppendingString:event];
        
        NSString *js = [NSString stringWithFormat:@"cordova.fireWindowEvent('%@')", result];
        [_commandDelegate evalJs:js];
    }
}

@end
